/// <reference types="node" />
import http = require('http');
import { ChainScoreDTO } from '../model/chainScoreDTO';
import { HeightInfoDTO } from '../model/heightInfoDTO';
import { Authentication } from '../model/models';
export declare enum ChainRoutesApiApiKeys {
}
export declare class ChainRoutesApi {
    protected _basePath: string;
    protected defaultHeaders: any;
    protected _useQuerystring: boolean;
    protected authentications: {
        'default': Authentication;
    };
    constructor(basePath?: string);
    useQuerystring: boolean;
    basePath: string;
    setDefaultAuthentication(auth: Authentication): void;
    setApiKey(key: ChainRoutesApiApiKeys, value: string): void;
    getChainHeight(options?: {
        headers: {
            [name: string]: string;
        };
    }): Promise<{
        response: http.IncomingMessage;
        body: HeightInfoDTO;
    }>;
    getChainScore(options?: {
        headers: {
            [name: string]: string;
        };
    }): Promise<{
        response: http.IncomingMessage;
        body: ChainScoreDTO;
    }>;
}
