/// <reference types="node" />
import http = require('http');
import { MultisigAccountGraphInfoDTO } from '../model/multisigAccountGraphInfoDTO';
import { MultisigAccountInfoDTO } from '../model/multisigAccountInfoDTO';
import { Authentication } from '../model/models';
export declare enum MultisigRoutesApiApiKeys {
}
export declare class MultisigRoutesApi {
    protected _basePath: string;
    protected defaultHeaders: any;
    protected _useQuerystring: boolean;
    protected authentications: {
        'default': Authentication;
    };
    constructor(basePath?: string);
    useQuerystring: boolean;
    basePath: string;
    setDefaultAuthentication(auth: Authentication): void;
    setApiKey(key: MultisigRoutesApiApiKeys, value: string): void;
    getAccountMultisig(accountId: string, options?: {
        headers: {
            [name: string]: string;
        };
    }): Promise<{
        response: http.IncomingMessage;
        body: MultisigAccountInfoDTO;
    }>;
    getAccountMultisigGraph(accountId: string, options?: {
        headers: {
            [name: string]: string;
        };
    }): Promise<{
        response: http.IncomingMessage;
        body: Array<MultisigAccountGraphInfoDTO>;
    }>;
}
