/// <reference types="node" />
import http = require('http');
import { NetworkFeesDTO } from '../model/networkFeesDTO';
import { NetworkTypeDTO } from '../model/networkTypeDTO';
import { Authentication } from '../model/models';
export declare enum NetworkRoutesApiApiKeys {
}
export declare class NetworkRoutesApi {
    protected _basePath: string;
    protected defaultHeaders: any;
    protected _useQuerystring: boolean;
    protected authentications: {
        'default': Authentication;
    };
    constructor(basePath?: string);
    useQuerystring: boolean;
    basePath: string;
    setDefaultAuthentication(auth: Authentication): void;
    setApiKey(key: NetworkRoutesApiApiKeys, value: string): void;
    getNetworkFees(options?: {
        headers: {
            [name: string]: string;
        };
    }): Promise<{
        response: http.IncomingMessage;
        body: NetworkFeesDTO;
    }>;
    getNetworkType(options?: {
        headers: {
            [name: string]: string;
        };
    }): Promise<{
        response: http.IncomingMessage;
        body: NetworkTypeDTO;
    }>;
}
