/// <reference types="node" />
import http = require('http');
import { NodeHealthInfoDTO } from '../model/nodeHealthInfoDTO';
import { NodeInfoDTO } from '../model/nodeInfoDTO';
import { NodeTimeDTO } from '../model/nodeTimeDTO';
import { ServerInfoDTO } from '../model/serverInfoDTO';
import { StorageInfoDTO } from '../model/storageInfoDTO';
import { Authentication } from '../model/models';
export declare enum NodeRoutesApiApiKeys {
}
export declare class NodeRoutesApi {
    protected _basePath: string;
    protected defaultHeaders: any;
    protected _useQuerystring: boolean;
    protected authentications: {
        'default': Authentication;
    };
    constructor(basePath?: string);
    useQuerystring: boolean;
    basePath: string;
    setDefaultAuthentication(auth: Authentication): void;
    setApiKey(key: NodeRoutesApiApiKeys, value: string): void;
    getNodeHealth(options?: {
        headers: {
            [name: string]: string;
        };
    }): Promise<{
        response: http.IncomingMessage;
        body: NodeHealthInfoDTO;
    }>;
    getNodeInfo(options?: {
        headers: {
            [name: string]: string;
        };
    }): Promise<{
        response: http.IncomingMessage;
        body: NodeInfoDTO;
    }>;
    getNodeStorage(options?: {
        headers: {
            [name: string]: string;
        };
    }): Promise<{
        response: http.IncomingMessage;
        body: StorageInfoDTO;
    }>;
    getNodeTime(options?: {
        headers: {
            [name: string]: string;
        };
    }): Promise<{
        response: http.IncomingMessage;
        body: NodeTimeDTO;
    }>;
    getServerInfo(options?: {
        headers: {
            [name: string]: string;
        };
    }): Promise<{
        response: http.IncomingMessage;
        body: ServerInfoDTO;
    }>;
}
