/// <reference types="node" />
import http = require('http');
import { AccountIds } from '../model/accountIds';
import { AccountRestrictionsInfoDTO } from '../model/accountRestrictionsInfoDTO';
import { Authentication } from '../model/models';
export declare enum RestrictionAccountRoutesApiApiKeys {
}
export declare class RestrictionAccountRoutesApi {
    protected _basePath: string;
    protected defaultHeaders: any;
    protected _useQuerystring: boolean;
    protected authentications: {
        'default': Authentication;
    };
    constructor(basePath?: string);
    useQuerystring: boolean;
    basePath: string;
    setDefaultAuthentication(auth: Authentication): void;
    setApiKey(key: RestrictionAccountRoutesApiApiKeys, value: string): void;
    getAccountRestrictions(accountId: string, options?: {
        headers: {
            [name: string]: string;
        };
    }): Promise<{
        response: http.IncomingMessage;
        body: AccountRestrictionsInfoDTO;
    }>;
    getAccountRestrictionsFromAccounts(accountIds?: AccountIds, options?: {
        headers: {
            [name: string]: string;
        };
    }): Promise<{
        response: http.IncomingMessage;
        body: Array<AccountRestrictionsInfoDTO>;
    }>;
}
