export declare enum TransactionStatusTypeEnum {
    Success,
    Neutral,
    Failure,
    FailureCorePastDeadline,
    FailureCoreFutureDeadline,
    FailureCoreInsufficientBalance,
    FailureCoreTooManyTransactions,
    FailureCoreNemesisAccountSignedAfterNemesisBlock,
    FailureCoreWrongNetwork,
    FailureCoreInvalidAddress,
    FailureCoreInvalidVersion,
    FailureCoreInvalidTransactionFee,
    FailureCoreBlockHarvesterIneligible,
    FailureCoreZeroAddress,
    FailureCoreZeroPublicKey,
    FailureCoreNonzeroInternalPadding,
    FailureHashAlreadyExists,
    FailureSignatureNotVerifiable,
    FailureAccountLinkInvalidAction,
    FailureAccountLinkLinkAlreadyExists,
    FailureAccountLinkUnknownLink,
    FailureAccountLinkInconsistentUnlinkData,
    FailureAccountLinkRemoteAccountIneligible,
    FailureAccountLinkRemoteAccountSignerProhibited,
    FailureAccountLinkRemoteAccountParticipantProhibited,
    FailureAggregateTooManyTransactions,
    FailureAggregateNoTransactions,
    FailureAggregateTooManyCosignatures,
    FailureAggregateRedundantCosignatures,
    FailureAggregateIneligibleCosignatories,
    FailureAggregateMissingCosignatures,
    FailureAggregateTransactionsHashMismatch,
    FailureLockHashInvalidMosaicId,
    FailureLockHashInvalidMosaicAmount,
    FailureLockHashHashAlreadyExists,
    FailureLockHashUnknownHash,
    FailureLockHashInactiveHash,
    FailureLockHashInvalidDuration,
    FailureLockSecretInvalidHashAlgorithm,
    FailureLockSecretHashAlreadyExists,
    FailureLockSecretProofSizeOutOfBounds,
    FailureLockSecretSecretMismatch,
    FailureLockSecretUnknownCompositeKey,
    FailureLockSecretInactiveSecret,
    FailureLockSecretHashAlgorithmMismatch,
    FailureLockSecretInvalidDuration,
    FailureMetadataValueTooSmall,
    FailureMetadataValueTooLarge,
    FailureMetadataValueSizeDeltaTooLarge,
    FailureMetadataValueSizeDeltaMismatch,
    FailureMetadataValueChangeIrreversible,
    FailureMosaicInvalidDuration,
    FailureMosaicInvalidName,
    FailureMosaicNameIdMismatch,
    FailureMosaicExpired,
    FailureMosaicOwnerConflict,
    FailureMosaicIdMismatch,
    FailureMosaicParentIdConflict,
    FailureMosaicInvalidProperty,
    FailureMosaicInvalidFlags,
    FailureMosaicInvalidDivisibility,
    FailureMosaicInvalidSupplyChangeAction,
    FailureMosaicInvalidSupplyChangeAmount,
    FailureMosaicInvalidId,
    FailureMosaicModificationDisallowed,
    FailureMosaicModificationNoChanges,
    FailureMosaicSupplyImmutable,
    FailureMosaicSupplyNegative,
    FailureMosaicSupplyExceeded,
    FailureMosaicNonTransferable,
    FailureMosaicMaxMosaicsExceeded,
    FailureMosaicRequiredPropertyFlagUnset,
    FailureMultisigAccountInBothSets,
    FailureMultisigMultipleDeletes,
    FailureMultisigRedundantModification,
    FailureMultisigUnknownMultisigAccount,
    FailureMultisigNotACosignatory,
    FailureMultisigAlreadyACosignatory,
    FailureMultisigMinSettingOutOfRange,
    FailureMultisigMinSettingLargerThanNumCosignatories,
    FailureMultisigInvalidModificationAction,
    FailureMultisigMaxCosignedAccounts,
    FailureMultisigMaxCosignatories,
    FailureMultisigLoop,
    FailureMultisigMaxMultisigDepth,
    FailureMultisigOperationProhibitedByAccount,
    FailureNamespaceInvalidDuration,
    FailureNamespaceInvalidName,
    FailureNamespaceNameIdMismatch,
    FailureNamespaceExpired,
    FailureNamespaceOwnerConflict,
    FailureNamespaceIdMismatch,
    FailureNamespaceInvalidRegistrationType,
    FailureNamespaceRootNameReserved,
    FailureNamespaceTooDeep,
    FailureNamespaceUnknownParent,
    FailureNamespaceAlreadyExists,
    FailureNamespaceAlreadyActive,
    FailureNamespaceEternalAfterNemesisBlock,
    FailureNamespaceMaxChildrenExceeded,
    FailureNamespaceAliasInvalidAction,
    FailureNamespaceUnknown,
    FailureNamespaceAliasAlreadyExists,
    FailureNamespaceUnknownAlias,
    FailureNamespaceAliasInconsistentUnlinkType,
    FailureNamespaceAliasInconsistentUnlinkData,
    FailureNamespaceAliasInvalidAddress,
    FailureRestrictionAccountInvalidRestrictionFlags,
    FailureRestrictionAccountInvalidModificationAction,
    FailureRestrictionAccountInvalidModificationAddress,
    FailureRestrictionAccountModificationOperationTypeIncompatible,
    FailureRestrictionAccountRedundantModification,
    FailureRestrictionAccountInvalidModification,
    FailureRestrictionAccountModificationCountExceeded,
    FailureRestrictionAccountNoModifications,
    FailureRestrictionAccountValuesCountExceeded,
    FailureRestrictionAccountInvalidValue,
    FailureRestrictionAccountAddressInteractionProhibited,
    FailureRestrictionAccountMosaicTransferProhibited,
    FailureRestrictionAccountOperationTypeProhibited,
    FailureRestrictionMosaicInvalidRestrictionType,
    FailureRestrictionMosaicPreviousValueMismatch,
    FailureRestrictionMosaicPreviousValueMustBeZero,
    FailureRestrictionMosaicMaxRestrictionsExceeded,
    FailureRestrictionMosaicCannotDeleteNonexistentRestriction,
    FailureRestrictionMosaicUnknownGlobalRestriction,
    FailureRestrictionMosaicInvalidGlobalRestriction,
    FailureRestrictionMosaicAccountUnauthorized,
    FailureTransferMessageTooLarge,
    FailureTransferOutOfOrderMosaics,
    FailureChainUnlinked,
    FailureChainBlockNotHit,
    FailureChainBlockInconsistentStateHash,
    FailureChainBlockInconsistentReceiptsHash,
    FailureChainUnconfirmedCacheTooFull,
    FailureConsumerEmptyInput,
    FailureConsumerBlockTransactionsHashMismatch,
    NeutralConsumerHashInRecencyCache,
    FailureConsumerRemoteChainTooManyBlocks,
    FailureConsumerRemoteChainImproperLink,
    FailureConsumerRemoteChainDuplicateTransactions,
    FailureConsumerRemoteChainUnlinked,
    FailureConsumerRemoteChainDifficultiesMismatch,
    FailureConsumerRemoteChainScoreNotBetter,
    FailureConsumerRemoteChainTooFarBehind,
    FailureConsumerRemoteChainTooFarInFuture,
    FailureConsumerBatchSignatureNotVerifiable,
    FailureExtensionPartialTransactionCachePrune,
    FailureExtensionPartialTransactionDependencyRemoved,
    FailureExtensionReadRateLimitExceeded
}
