/*
 * Copyright 2019 NEM
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */
/**
 * Catapult REST Endpoints
 * OpenAPI Specification of catapult-rest 1.0.20.16
 *
 * The version of the OpenAPI document: 0.8.4
 * 
 *
 * NOTE: This class is auto generated by OpenAPI Generator (https://openapi-generator.tech).
 * https://openapi-generator.tech
 * Do not edit the class manually.
 */

import { AccountMosaicRestrictionTransactionBodyDTO } from './accountMosaicRestrictionTransactionBodyDTO';
import { AccountRestrictionFlagsEnum } from './accountRestrictionFlagsEnum';
import { NetworkTypeEnum } from './networkTypeEnum';
import { TransactionDTO } from './transactionDTO';

/**
* Transaction to prevent incoming transactions containing a given set of mosaics.
*/
export class AccountMosaicRestrictionTransactionDTO {
    /**
    * Entity\'s signature generated by the signer.
    */
    'signature': string;
    /**
    * Public key.
    */
    'signerPublicKey': string;
    /**
    * Entity version.
    */
    'version': number;
    'network': NetworkTypeEnum;
    'type': number;
    /**
    * Absolute amount. An amount of 123456789 (absolute) for a mosaic with divisibility 6 means 123.456789 (relative).
    */
    'maxFee': string;
    /**
    * Duration expressed in number of blocks.
    */
    'deadline': string;
    'restrictionFlags': AccountRestrictionFlagsEnum;
    /**
    * Account restriction additions.
    */
    'restrictionAdditions': Array<string>;
    /**
    * Account restriction deletions.
    */
    'restrictionDeletions': Array<string>;

    static discriminator: string | undefined = undefined;

    static attributeTypeMap: Array<{name: string, baseName: string, type: string}> = [
        {
            "name": "signature",
            "baseName": "signature",
            "type": "string"
        },
        {
            "name": "signerPublicKey",
            "baseName": "signerPublicKey",
            "type": "string"
        },
        {
            "name": "version",
            "baseName": "version",
            "type": "number"
        },
        {
            "name": "network",
            "baseName": "network",
            "type": "NetworkTypeEnum"
        },
        {
            "name": "type",
            "baseName": "type",
            "type": "number"
        },
        {
            "name": "maxFee",
            "baseName": "maxFee",
            "type": "string"
        },
        {
            "name": "deadline",
            "baseName": "deadline",
            "type": "string"
        },
        {
            "name": "restrictionFlags",
            "baseName": "restrictionFlags",
            "type": "AccountRestrictionFlagsEnum"
        },
        {
            "name": "restrictionAdditions",
            "baseName": "restrictionAdditions",
            "type": "Array<string>"
        },
        {
            "name": "restrictionDeletions",
            "baseName": "restrictionDeletions",
            "type": "Array<string>"
        }    ];

    static getAttributeTypeMap() {
        return AccountMosaicRestrictionTransactionDTO.attributeTypeMap;
    }
}

