/*
 * Copyright 2019 NEM
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */
/**
 * Catapult REST Endpoints
 * OpenAPI Specification of catapult-rest 1.0.20.16
 *
 * The version of the OpenAPI document: 0.8.4
 * 
 *
 * NOTE: This class is auto generated by OpenAPI Generator (https://openapi-generator.tech).
 * https://openapi-generator.tech
 * Do not edit the class manually.
 */

import { AliasDTO } from './aliasDTO';
import { NamespaceRegistrationTypeEnum } from './namespaceRegistrationTypeEnum';

export class NamespaceDTO {
    'registrationType': NamespaceRegistrationTypeEnum;
    /**
    * Level of the namespace.
    */
    'depth': number;
    /**
    * Namespace identifier.
    */
    'level0': string;
    /**
    * Namespace identifier.
    */
    'level1'?: string;
    /**
    * Namespace identifier.
    */
    'level2'?: string;
    'alias': AliasDTO;
    /**
    * Namespace identifier.
    */
    'parentId': string;
    /**
    * Public key.
    */
    'ownerPublicKey': string;
    /**
    * Address expressed in hexadecimal base.
    */
    'ownerAddress': string;
    /**
    * Height of the blockchain.
    */
    'startHeight': string;
    /**
    * Height of the blockchain.
    */
    'endHeight': string;

    static discriminator: string | undefined = undefined;

    static attributeTypeMap: Array<{name: string, baseName: string, type: string}> = [
        {
            "name": "registrationType",
            "baseName": "registrationType",
            "type": "NamespaceRegistrationTypeEnum"
        },
        {
            "name": "depth",
            "baseName": "depth",
            "type": "number"
        },
        {
            "name": "level0",
            "baseName": "level0",
            "type": "string"
        },
        {
            "name": "level1",
            "baseName": "level1",
            "type": "string"
        },
        {
            "name": "level2",
            "baseName": "level2",
            "type": "string"
        },
        {
            "name": "alias",
            "baseName": "alias",
            "type": "AliasDTO"
        },
        {
            "name": "parentId",
            "baseName": "parentId",
            "type": "string"
        },
        {
            "name": "ownerPublicKey",
            "baseName": "ownerPublicKey",
            "type": "string"
        },
        {
            "name": "ownerAddress",
            "baseName": "ownerAddress",
            "type": "string"
        },
        {
            "name": "startHeight",
            "baseName": "startHeight",
            "type": "string"
        },
        {
            "name": "endHeight",
            "baseName": "endHeight",
            "type": "string"
        }    ];

    static getAttributeTypeMap() {
        return NamespaceDTO.attributeTypeMap;
    }
}

