/*
 * Copyright 2019 NEM
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */
/**
 * Catapult REST Endpoints
 * OpenAPI Specification of catapult-rest 1.0.20.16
 *
 * The version of the OpenAPI document: 0.8.4
 * 
 *
 * NOTE: This class is auto generated by OpenAPI Generator (https://openapi-generator.tech).
 * https://openapi-generator.tech
 * Do not edit the class manually.
 */


/**
* Status of the transaction: * Success - * Neutral - * Failure - * Failure_Core_Past_Deadline - Validation failed because the deadline passed. * Failure_Core_Future_Deadline - Validation failed because the deadline is too far in the future. * Failure_Core_Insufficient_Balance - Validation failed because the account has an insufficient balance. * Failure_Core_Too_Many_Transactions - Validation failed because there are too many transactions in a block. * Failure_Core_Nemesis_Account_Signed_After_Nemesis_Block - Validation failed because an entity originated from the nemesis account after the nemesis block. * Failure_Core_Wrong_Network - Validation failed because the entity has the wrong network specified. * Failure_Core_Invalid_Address - Validation failed because an address is invalid. * Failure_Core_Invalid_Version - Validation failed because entity version is invalid. * Failure_Core_Invalid_Transaction_Fee - Validation failed because a transaction fee is invalid. * Failure_Core_Block_Harvester_Ineligible - Validation failed because a block was harvested by an ineligible harvester. * Failure_Core_Zero_Address - Validation failed because an address is zero. * Failure_Core_Zero_Public_Key - Validation failed because a public key is zero. * Failure_Core_Nonzero_Internal_Padding - Validation failed because internal padding is nonzero. * Failure_Hash_Already_Exists - * Failure_Signature_Not_Verifiable - Validation failed because the verification of the signature failed. * Failure_AccountLink_Invalid_Action - Validation failed because account link action is invalid. * Failure_AccountLink_Link_Already_Exists - Validation failed because main account is already linked to another account. * Failure_AccountLink_Unknown_Link - Validation failed because main account is not linked to another account. * Failure_AccountLink_Inconsistent_Unlink_Data - Validation failed because unlink data is not consistent with existing account link. * Failure_AccountLink_Remote_Account_Ineligible - Validation failed because link is attempting to convert ineligible account to remote. * Failure_AccountLink_Remote_Account_Signer_Prohibited - Validation failed because remote is not allowed to sign a transaction. * Failure_AccountLink_Remote_Account_Participant_Prohibited - Validation failed because remote is not allowed to participate in the transaction. * Failure_Aggregate_Too_Many_Transactions - Validation failed because aggregate has too many transactions. * Failure_Aggregate_No_Transactions - Validation failed because aggregate does not have any transactions. * Failure_Aggregate_Too_Many_Cosignatures - Validation failed because aggregate has too many cosignatures. * Failure_Aggregate_Redundant_Cosignatures - Validation failed because redundant cosignatures are present. * Failure_Aggregate_Ineligible_Cosignatories - Validation failed because at least one cosignatory is ineligible. * Failure_Aggregate_Missing_Cosignatures - Validation failed because at least one required cosignature is missing. * Failure_Aggregate_Transactions_Hash_Mismatch - Validation failed because the aggregate transactions hash does not match the calculated value. * Failure_LockHash_Invalid_Mosaic_Id - Validation failed because lock does not allow the specified mosaic. * Failure_LockHash_Invalid_Mosaic_Amount - Validation failed because lock does not allow the specified amount. * Failure_LockHash_Hash_Already_Exists - Validation failed because hash is already present in cache. * Failure_LockHash_Unknown_Hash - Validation failed because hash is not present in cache. * Failure_LockHash_Inactive_Hash - Validation failed because hash is inactive. * Failure_LockHash_Invalid_Duration - Validation failed because duration is too long. * Failure_LockSecret_Invalid_Hash_Algorithm - Validation failed because hash algorithm for lock type secret is invalid. * Failure_LockSecret_Hash_Already_Exists - Validation failed because hash is already present in cache. * Failure_LockSecret_Proof_Size_Out_Of_Bounds - Validation failed because proof is too small or too large. * Failure_LockSecret_Secret_Mismatch - Validation failed because secret does not match proof. * Failure_LockSecret_Unknown_Composite_Key - Validation failed because composite key is unknown. * Failure_LockSecret_Inactive_Secret - Validation failed because secret is inactive. * Failure_LockSecret_Hash_Algorithm_Mismatch - Validation failed because hash algorithm does not match. * Failure_LockSecret_Invalid_Duration - Validation failed because duration is too long. * Failure_Metadata_Value_Too_Small - Validation failed because the metadata value is too small. * Failure_Metadata_Value_Too_Large - Validation failed because the metadata value is too large. * Failure_Metadata_Value_Size_Delta_Too_Large - Validation failed because the metadata value size delta is larger in magnitude than the value size. * Failure_Metadata_Value_Size_Delta_Mismatch - Validation failed because the metadata value size delta does not match expected value based on the current state. * Failure_Metadata_Value_Change_Irreversible - Validation failed because a metadata value change (truncation) is irreversible. * Failure_Mosaic_Invalid_Duration - Validation failed because the duration has an invalid value. * Failure_Mosaic_Invalid_Name - Validation failed because the name is invalid. * Failure_Mosaic_Name_Id_Mismatch - Validation failed because the name and id don\'t match. * Failure_Mosaic_Expired - Validation failed because the parent is expired. * Failure_Mosaic_Owner_Conflict - Validation failed because the parent owner conflicts with the child owner. * Failure_Mosaic_Id_Mismatch - Validation failed because the id is not the expected id generated from signer and nonce. * Failure_Mosaic_Parent_Id_Conflict - Validation failed because the existing parent id does not match the supplied parent id. * Failure_Mosaic_Invalid_Property - Validation failed because a mosaic property is invalid. * Failure_Mosaic_Invalid_Flags - Validation failed because the mosaic flags are invalid. * Failure_Mosaic_Invalid_Divisibility - Validation failed because the mosaic divisibility is invalid. * Failure_Mosaic_Invalid_Supply_Change_Action - Validation failed because the mosaic supply change action is invalid. * Failure_Mosaic_Invalid_Supply_Change_Amount - Validation failed because the mosaic supply change amount is invalid. * Failure_Mosaic_Invalid_Id - Validation failed because the mosaic id is invalid. * Failure_Mosaic_Modification_Disallowed - Validation failed because mosaic modification is not allowed. * Failure_Mosaic_Modification_No_Changes - Validation failed because mosaic modification would not result in any changes. * Failure_Mosaic_Supply_Immutable - Validation failed because the mosaic supply is immutable. * Failure_Mosaic_Supply_Negative - Validation failed because the resulting mosaic supply is negative. * Failure_Mosaic_Supply_Exceeded - Validation failed because the resulting mosaic supply exceeds the maximum allowed value. * Failure_Mosaic_Non_Transferable - Validation failed because the mosaic is not transferable. * Failure_Mosaic_Max_Mosaics_Exceeded - Validation failed because the credit of the mosaic would exceed the maximum of different mosaics an account is allowed to own. * Failure_Mosaic_Required_Property_Flag_Unset - Validation failed because the mosaic has at least one required property flag unset. * Failure_Multisig_Account_In_Both_Sets - Validation failed because account is specified to be both added and removed. * Failure_Multisig_Multiple_Deletes - Validation failed because multiple removals are present. * Failure_Multisig_Redundant_Modification - Validation failed because a modification is redundant. * Failure_Multisig_Unknown_Multisig_Account - Validation failed because account is not in multisig cache. * Failure_Multisig_Not_A_Cosignatory - Validation failed because account to be removed is not present. * Failure_Multisig_Already_A_Cosignatory - Validation failed because account to be added is already a cosignatory. * Failure_Multisig_Min_Setting_Out_Of_Range - Validation failed because new minimum settings are out of range. * Failure_Multisig_Min_Setting_Larger_Than_Num_Cosignatories - Validation failed because min settings are larger than number of cosignatories. * Failure_Multisig_Invalid_Modification_Action - Validation failed because the modification action is invalid. * Failure_Multisig_Max_Cosigned_Accounts - Validation failed because the cosignatory already cosigns the maximum number of accounts. * Failure_Multisig_Max_Cosignatories - Validation failed because the multisig account already has the maximum number of cosignatories. * Failure_Multisig_Loop - Validation failed because a multisig loop is created. * Failure_Multisig_Max_Multisig_Depth - Validation failed because the max multisig depth is exceeded. * Failure_Multisig_Operation_Prohibited_By_Account - Validation failed because an operation is not permitted by a multisig account. * Failure_Namespace_Invalid_Duration - Validation failed because the duration has an invalid value. * Failure_Namespace_Invalid_Name - Validation failed because the name is invalid. * Failure_Namespace_Name_Id_Mismatch - Validation failed because the name and id don\'t match. * Failure_Namespace_Expired - Validation failed because the parent is expired. * Failure_Namespace_Owner_Conflict - Validation failed because the parent owner conflicts with the child owner. * Failure_Namespace_Id_Mismatch - Validation failed because the id is not the expected id generated from signer and nonce. * Failure_Namespace_Invalid_Registration_Type - Validation failed because the namespace registration type is invalid. * Failure_Namespace_Root_Name_Reserved - Validation failed because the root namespace has a reserved name. * Failure_Namespace_Too_Deep - Validation failed because the resulting namespace would exceed the maximum allowed namespace depth. * Failure_Namespace_Unknown_Parent - Validation failed because the namespace parent is unknown. * Failure_Namespace_Already_Exists - Validation failed because the namespace already exists. * Failure_Namespace_Already_Active - Validation failed because the namespace is already active. * Failure_Namespace_Eternal_After_Nemesis_Block - Validation failed because an eternal namespace was received after the nemesis block. * Failure_Namespace_Max_Children_Exceeded - Validation failed because the maximum number of children for a root namespace was exceeded. * Failure_Namespace_Alias_Invalid_Action - Validation failed because alias action is invalid. * Failure_Namespace_Unknown - Validation failed because namespace does not exist. * Failure_Namespace_Alias_Already_Exists - Validation failed because namespace is already linked to an alias. * Failure_Namespace_Unknown_Alias - Validation failed because namespace is not linked to an alias. * Failure_Namespace_Alias_Inconsistent_Unlink_Type - Validation failed because unlink type is not consistent with existing alias. * Failure_Namespace_Alias_Inconsistent_Unlink_Data - Validation failed because unlink data is not consistent with existing alias. * Failure_Namespace_Alias_Invalid_Address - Validation failed because aliased address is invalid. * Failure_RestrictionAccount_Invalid_Restriction_Flags - Validation failed because the account restriction flags are invalid. * Failure_RestrictionAccount_Invalid_Modification_Action - Validation failed because a modification action is invalid. * Failure_RestrictionAccount_Invalid_Modification_Address - Validation failed because a modification address is invalid. * Failure_RestrictionAccount_Modification_Operation_Type_Incompatible - Validation failed because the operation type is incompatible. *Note*: This indicates that the existing restrictions have a different operation type than that specified in the notification. * Failure_RestrictionAccount_Redundant_Modification - Validation failed because a modification is redundant. * Failure_RestrictionAccount_Invalid_Modification - Validation failed because a value is not in the container. * Failure_RestrictionAccount_Modification_Count_Exceeded - Validation failed because the transaction has too many modifications. * Failure_RestrictionAccount_No_Modifications - Validation failed because the transaction has no modifications. * Failure_RestrictionAccount_Values_Count_Exceeded - Validation failed because the resulting account restriction has too many values. * Failure_RestrictionAccount_Invalid_Value - Validation failed because the account restriction value is invalid. * Failure_RestrictionAccount_Address_Interaction_Prohibited - Validation failed because the addresses involved in the transaction are not allowed to interact. * Failure_RestrictionAccount_Mosaic_Transfer_Prohibited - Validation failed because the mosaic transfer is prohibited by the recipient. * Failure_RestrictionAccount_Operation_Type_Prohibited - Validation failed because the operation type is not allowed to be initiated by the signer. * Failure_RestrictionMosaic_Invalid_Restriction_Type - Validation failed because the mosaic restriction type is invalid. * Failure_RestrictionMosaic_Previous_Value_Mismatch - Validation failed because specified previous value does not match current value. * Failure_RestrictionMosaic_Previous_Value_Must_Be_Zero - Validation failed because specified previous value is nonzero. * Failure_RestrictionMosaic_Max_Restrictions_Exceeded - Validation failed because the maximum number of restrictions would be exeeded. * Failure_RestrictionMosaic_Cannot_Delete_Nonexistent_Restriction - Validation failed because nonexistent restriction cannot be deleted. * Failure_RestrictionMosaic_Unknown_Global_Restriction - Validation failed because required global restriction does not exist. * Failure_RestrictionMosaic_Invalid_Global_Restriction - Validation failed because mosaic has invalid global restriction. * Failure_RestrictionMosaic_Account_Unauthorized - Validation failed because account lacks proper permissions to move mosaic. * Failure_Transfer_Message_Too_Large - Validation failed because the message is too large. * Failure_Transfer_Out_Of_Order_Mosaics - Validation failed because mosaics are out of order. * Failure_Chain_Unlinked - Validation failed because a block was received that did not link with the existing chain. * Failure_Chain_Block_Not_Hit - Validation failed because a block was received that is not a hit. * Failure_Chain_Block_Inconsistent_State_Hash - Validation failed because a block was received that has an inconsistent state hash. * Failure_Chain_Block_Inconsistent_Receipts_Hash - Validation failed because a block was received that has an inconsistent receipts hash. * Failure_Chain_Unconfirmed_Cache_Too_Full - Validation failed because the unconfirmed cache is too full. * Failure_Consumer_Empty_Input - Validation failed because the consumer input is empty. * Failure_Consumer_Block_Transactions_Hash_Mismatch - Validation failed because the block transactions hash does not match the calculated value. * Neutral_Consumer_Hash_In_Recency_Cache - Validation failed because an entity hash is present in the recency cache. * Failure_Consumer_Remote_Chain_Too_Many_Blocks - Validation failed because the chain part has too many blocks. * Failure_Consumer_Remote_Chain_Improper_Link - Validation failed because the chain is internally improperly linked. * Failure_Consumer_Remote_Chain_Duplicate_Transactions - Validation failed because the chain part contains duplicate transactions. * Failure_Consumer_Remote_Chain_Unlinked - Validation failed because the chain part does not link to the current chain. * Failure_Consumer_Remote_Chain_Difficulties_Mismatch - Validation failed because the remote chain difficulties do not match the calculated difficulties. * Failure_Consumer_Remote_Chain_Score_Not_Better - Validation failed because the remote chain score is not better. * Failure_Consumer_Remote_Chain_Too_Far_Behind - Validation failed because the remote chain is too far behind. * Failure_Consumer_Remote_Chain_Too_Far_In_Future - Validation failed because the remote chain timestamp is too far in the future. * Failure_Consumer_Batch_Signature_Not_Verifiable - Validation failed because the verification of the signature failed during a batch operation. * Failure_Extension_Partial_Transaction_Cache_Prune - Validation failed because the partial transaction was pruned from the temporal cache. * Failure_Extension_Partial_Transaction_Dependency_Removed - Validation failed because the partial transaction was pruned from the temporal cache due to its dependency being removed. * Failure_Extension_Read_Rate_Limit_Exceeded - Validation failed because socket read rate limit was exceeded. 
*/
export enum TransactionStatusTypeEnum {
    Success = <any> 'Success',
    Neutral = <any> 'Neutral',
    Failure = <any> 'Failure',
    FailureCorePastDeadline = <any> 'Failure_Core_Past_Deadline',
    FailureCoreFutureDeadline = <any> 'Failure_Core_Future_Deadline',
    FailureCoreInsufficientBalance = <any> 'Failure_Core_Insufficient_Balance',
    FailureCoreTooManyTransactions = <any> 'Failure_Core_Too_Many_Transactions',
    FailureCoreNemesisAccountSignedAfterNemesisBlock = <any> 'Failure_Core_Nemesis_Account_Signed_After_Nemesis_Block',
    FailureCoreWrongNetwork = <any> 'Failure_Core_Wrong_Network',
    FailureCoreInvalidAddress = <any> 'Failure_Core_Invalid_Address',
    FailureCoreInvalidVersion = <any> 'Failure_Core_Invalid_Version',
    FailureCoreInvalidTransactionFee = <any> 'Failure_Core_Invalid_Transaction_Fee',
    FailureCoreBlockHarvesterIneligible = <any> 'Failure_Core_Block_Harvester_Ineligible',
    FailureCoreZeroAddress = <any> 'Failure_Core_Zero_Address',
    FailureCoreZeroPublicKey = <any> 'Failure_Core_Zero_Public_Key',
    FailureCoreNonzeroInternalPadding = <any> 'Failure_Core_Nonzero_Internal_Padding',
    FailureHashAlreadyExists = <any> 'Failure_Hash_Already_Exists',
    FailureSignatureNotVerifiable = <any> 'Failure_Signature_Not_Verifiable',
    FailureAccountLinkInvalidAction = <any> 'Failure_AccountLink_Invalid_Action',
    FailureAccountLinkLinkAlreadyExists = <any> 'Failure_AccountLink_Link_Already_Exists',
    FailureAccountLinkUnknownLink = <any> 'Failure_AccountLink_Unknown_Link',
    FailureAccountLinkInconsistentUnlinkData = <any> 'Failure_AccountLink_Inconsistent_Unlink_Data',
    FailureAccountLinkRemoteAccountIneligible = <any> 'Failure_AccountLink_Remote_Account_Ineligible',
    FailureAccountLinkRemoteAccountSignerProhibited = <any> 'Failure_AccountLink_Remote_Account_Signer_Prohibited',
    FailureAccountLinkRemoteAccountParticipantProhibited = <any> 'Failure_AccountLink_Remote_Account_Participant_Prohibited',
    FailureAggregateTooManyTransactions = <any> 'Failure_Aggregate_Too_Many_Transactions',
    FailureAggregateNoTransactions = <any> 'Failure_Aggregate_No_Transactions',
    FailureAggregateTooManyCosignatures = <any> 'Failure_Aggregate_Too_Many_Cosignatures',
    FailureAggregateRedundantCosignatures = <any> 'Failure_Aggregate_Redundant_Cosignatures',
    FailureAggregateIneligibleCosignatories = <any> 'Failure_Aggregate_Ineligible_Cosignatories',
    FailureAggregateMissingCosignatures = <any> 'Failure_Aggregate_Missing_Cosignatures',
    FailureAggregateTransactionsHashMismatch = <any> 'Failure_Aggregate_Transactions_Hash_Mismatch',
    FailureLockHashInvalidMosaicId = <any> 'Failure_LockHash_Invalid_Mosaic_Id',
    FailureLockHashInvalidMosaicAmount = <any> 'Failure_LockHash_Invalid_Mosaic_Amount',
    FailureLockHashHashAlreadyExists = <any> 'Failure_LockHash_Hash_Already_Exists',
    FailureLockHashUnknownHash = <any> 'Failure_LockHash_Unknown_Hash',
    FailureLockHashInactiveHash = <any> 'Failure_LockHash_Inactive_Hash',
    FailureLockHashInvalidDuration = <any> 'Failure_LockHash_Invalid_Duration',
    FailureLockSecretInvalidHashAlgorithm = <any> 'Failure_LockSecret_Invalid_Hash_Algorithm',
    FailureLockSecretHashAlreadyExists = <any> 'Failure_LockSecret_Hash_Already_Exists',
    FailureLockSecretProofSizeOutOfBounds = <any> 'Failure_LockSecret_Proof_Size_Out_Of_Bounds',
    FailureLockSecretSecretMismatch = <any> 'Failure_LockSecret_Secret_Mismatch',
    FailureLockSecretUnknownCompositeKey = <any> 'Failure_LockSecret_Unknown_Composite_Key',
    FailureLockSecretInactiveSecret = <any> 'Failure_LockSecret_Inactive_Secret',
    FailureLockSecretHashAlgorithmMismatch = <any> 'Failure_LockSecret_Hash_Algorithm_Mismatch',
    FailureLockSecretInvalidDuration = <any> 'Failure_LockSecret_Invalid_Duration',
    FailureMetadataValueTooSmall = <any> 'Failure_Metadata_Value_Too_Small',
    FailureMetadataValueTooLarge = <any> 'Failure_Metadata_Value_Too_Large',
    FailureMetadataValueSizeDeltaTooLarge = <any> 'Failure_Metadata_Value_Size_Delta_Too_Large',
    FailureMetadataValueSizeDeltaMismatch = <any> 'Failure_Metadata_Value_Size_Delta_Mismatch',
    FailureMetadataValueChangeIrreversible = <any> 'Failure_Metadata_Value_Change_Irreversible',
    FailureMosaicInvalidDuration = <any> 'Failure_Mosaic_Invalid_Duration',
    FailureMosaicInvalidName = <any> 'Failure_Mosaic_Invalid_Name',
    FailureMosaicNameIdMismatch = <any> 'Failure_Mosaic_Name_Id_Mismatch',
    FailureMosaicExpired = <any> 'Failure_Mosaic_Expired',
    FailureMosaicOwnerConflict = <any> 'Failure_Mosaic_Owner_Conflict',
    FailureMosaicIdMismatch = <any> 'Failure_Mosaic_Id_Mismatch',
    FailureMosaicParentIdConflict = <any> 'Failure_Mosaic_Parent_Id_Conflict',
    FailureMosaicInvalidProperty = <any> 'Failure_Mosaic_Invalid_Property',
    FailureMosaicInvalidFlags = <any> 'Failure_Mosaic_Invalid_Flags',
    FailureMosaicInvalidDivisibility = <any> 'Failure_Mosaic_Invalid_Divisibility',
    FailureMosaicInvalidSupplyChangeAction = <any> 'Failure_Mosaic_Invalid_Supply_Change_Action',
    FailureMosaicInvalidSupplyChangeAmount = <any> 'Failure_Mosaic_Invalid_Supply_Change_Amount',
    FailureMosaicInvalidId = <any> 'Failure_Mosaic_Invalid_Id',
    FailureMosaicModificationDisallowed = <any> 'Failure_Mosaic_Modification_Disallowed',
    FailureMosaicModificationNoChanges = <any> 'Failure_Mosaic_Modification_No_Changes',
    FailureMosaicSupplyImmutable = <any> 'Failure_Mosaic_Supply_Immutable',
    FailureMosaicSupplyNegative = <any> 'Failure_Mosaic_Supply_Negative',
    FailureMosaicSupplyExceeded = <any> 'Failure_Mosaic_Supply_Exceeded',
    FailureMosaicNonTransferable = <any> 'Failure_Mosaic_Non_Transferable',
    FailureMosaicMaxMosaicsExceeded = <any> 'Failure_Mosaic_Max_Mosaics_Exceeded',
    FailureMosaicRequiredPropertyFlagUnset = <any> 'Failure_Mosaic_Required_Property_Flag_Unset',
    FailureMultisigAccountInBothSets = <any> 'Failure_Multisig_Account_In_Both_Sets',
    FailureMultisigMultipleDeletes = <any> 'Failure_Multisig_Multiple_Deletes',
    FailureMultisigRedundantModification = <any> 'Failure_Multisig_Redundant_Modification',
    FailureMultisigUnknownMultisigAccount = <any> 'Failure_Multisig_Unknown_Multisig_Account',
    FailureMultisigNotACosignatory = <any> 'Failure_Multisig_Not_A_Cosignatory',
    FailureMultisigAlreadyACosignatory = <any> 'Failure_Multisig_Already_A_Cosignatory',
    FailureMultisigMinSettingOutOfRange = <any> 'Failure_Multisig_Min_Setting_Out_Of_Range',
    FailureMultisigMinSettingLargerThanNumCosignatories = <any> 'Failure_Multisig_Min_Setting_Larger_Than_Num_Cosignatories',
    FailureMultisigInvalidModificationAction = <any> 'Failure_Multisig_Invalid_Modification_Action',
    FailureMultisigMaxCosignedAccounts = <any> 'Failure_Multisig_Max_Cosigned_Accounts',
    FailureMultisigMaxCosignatories = <any> 'Failure_Multisig_Max_Cosignatories',
    FailureMultisigLoop = <any> 'Failure_Multisig_Loop',
    FailureMultisigMaxMultisigDepth = <any> 'Failure_Multisig_Max_Multisig_Depth',
    FailureMultisigOperationProhibitedByAccount = <any> 'Failure_Multisig_Operation_Prohibited_By_Account',
    FailureNamespaceInvalidDuration = <any> 'Failure_Namespace_Invalid_Duration',
    FailureNamespaceInvalidName = <any> 'Failure_Namespace_Invalid_Name',
    FailureNamespaceNameIdMismatch = <any> 'Failure_Namespace_Name_Id_Mismatch',
    FailureNamespaceExpired = <any> 'Failure_Namespace_Expired',
    FailureNamespaceOwnerConflict = <any> 'Failure_Namespace_Owner_Conflict',
    FailureNamespaceIdMismatch = <any> 'Failure_Namespace_Id_Mismatch',
    FailureNamespaceInvalidRegistrationType = <any> 'Failure_Namespace_Invalid_Registration_Type',
    FailureNamespaceRootNameReserved = <any> 'Failure_Namespace_Root_Name_Reserved',
    FailureNamespaceTooDeep = <any> 'Failure_Namespace_Too_Deep',
    FailureNamespaceUnknownParent = <any> 'Failure_Namespace_Unknown_Parent',
    FailureNamespaceAlreadyExists = <any> 'Failure_Namespace_Already_Exists',
    FailureNamespaceAlreadyActive = <any> 'Failure_Namespace_Already_Active',
    FailureNamespaceEternalAfterNemesisBlock = <any> 'Failure_Namespace_Eternal_After_Nemesis_Block',
    FailureNamespaceMaxChildrenExceeded = <any> 'Failure_Namespace_Max_Children_Exceeded',
    FailureNamespaceAliasInvalidAction = <any> 'Failure_Namespace_Alias_Invalid_Action',
    FailureNamespaceUnknown = <any> 'Failure_Namespace_Unknown',
    FailureNamespaceAliasAlreadyExists = <any> 'Failure_Namespace_Alias_Already_Exists',
    FailureNamespaceUnknownAlias = <any> 'Failure_Namespace_Unknown_Alias',
    FailureNamespaceAliasInconsistentUnlinkType = <any> 'Failure_Namespace_Alias_Inconsistent_Unlink_Type',
    FailureNamespaceAliasInconsistentUnlinkData = <any> 'Failure_Namespace_Alias_Inconsistent_Unlink_Data',
    FailureNamespaceAliasInvalidAddress = <any> 'Failure_Namespace_Alias_Invalid_Address',
    FailureRestrictionAccountInvalidRestrictionFlags = <any> 'Failure_RestrictionAccount_Invalid_Restriction_Flags',
    FailureRestrictionAccountInvalidModificationAction = <any> 'Failure_RestrictionAccount_Invalid_Modification_Action',
    FailureRestrictionAccountInvalidModificationAddress = <any> 'Failure_RestrictionAccount_Invalid_Modification_Address',
    FailureRestrictionAccountModificationOperationTypeIncompatible = <any> 'Failure_RestrictionAccount_Modification_Operation_Type_Incompatible',
    FailureRestrictionAccountRedundantModification = <any> 'Failure_RestrictionAccount_Redundant_Modification',
    FailureRestrictionAccountInvalidModification = <any> 'Failure_RestrictionAccount_Invalid_Modification',
    FailureRestrictionAccountModificationCountExceeded = <any> 'Failure_RestrictionAccount_Modification_Count_Exceeded',
    FailureRestrictionAccountNoModifications = <any> 'Failure_RestrictionAccount_No_Modifications',
    FailureRestrictionAccountValuesCountExceeded = <any> 'Failure_RestrictionAccount_Values_Count_Exceeded',
    FailureRestrictionAccountInvalidValue = <any> 'Failure_RestrictionAccount_Invalid_Value',
    FailureRestrictionAccountAddressInteractionProhibited = <any> 'Failure_RestrictionAccount_Address_Interaction_Prohibited',
    FailureRestrictionAccountMosaicTransferProhibited = <any> 'Failure_RestrictionAccount_Mosaic_Transfer_Prohibited',
    FailureRestrictionAccountOperationTypeProhibited = <any> 'Failure_RestrictionAccount_Operation_Type_Prohibited',
    FailureRestrictionMosaicInvalidRestrictionType = <any> 'Failure_RestrictionMosaic_Invalid_Restriction_Type',
    FailureRestrictionMosaicPreviousValueMismatch = <any> 'Failure_RestrictionMosaic_Previous_Value_Mismatch',
    FailureRestrictionMosaicPreviousValueMustBeZero = <any> 'Failure_RestrictionMosaic_Previous_Value_Must_Be_Zero',
    FailureRestrictionMosaicMaxRestrictionsExceeded = <any> 'Failure_RestrictionMosaic_Max_Restrictions_Exceeded',
    FailureRestrictionMosaicCannotDeleteNonexistentRestriction = <any> 'Failure_RestrictionMosaic_Cannot_Delete_Nonexistent_Restriction',
    FailureRestrictionMosaicUnknownGlobalRestriction = <any> 'Failure_RestrictionMosaic_Unknown_Global_Restriction',
    FailureRestrictionMosaicInvalidGlobalRestriction = <any> 'Failure_RestrictionMosaic_Invalid_Global_Restriction',
    FailureRestrictionMosaicAccountUnauthorized = <any> 'Failure_RestrictionMosaic_Account_Unauthorized',
    FailureTransferMessageTooLarge = <any> 'Failure_Transfer_Message_Too_Large',
    FailureTransferOutOfOrderMosaics = <any> 'Failure_Transfer_Out_Of_Order_Mosaics',
    FailureChainUnlinked = <any> 'Failure_Chain_Unlinked',
    FailureChainBlockNotHit = <any> 'Failure_Chain_Block_Not_Hit',
    FailureChainBlockInconsistentStateHash = <any> 'Failure_Chain_Block_Inconsistent_State_Hash',
    FailureChainBlockInconsistentReceiptsHash = <any> 'Failure_Chain_Block_Inconsistent_Receipts_Hash',
    FailureChainUnconfirmedCacheTooFull = <any> 'Failure_Chain_Unconfirmed_Cache_Too_Full',
    FailureConsumerEmptyInput = <any> 'Failure_Consumer_Empty_Input',
    FailureConsumerBlockTransactionsHashMismatch = <any> 'Failure_Consumer_Block_Transactions_Hash_Mismatch',
    NeutralConsumerHashInRecencyCache = <any> 'Neutral_Consumer_Hash_In_Recency_Cache',
    FailureConsumerRemoteChainTooManyBlocks = <any> 'Failure_Consumer_Remote_Chain_Too_Many_Blocks',
    FailureConsumerRemoteChainImproperLink = <any> 'Failure_Consumer_Remote_Chain_Improper_Link',
    FailureConsumerRemoteChainDuplicateTransactions = <any> 'Failure_Consumer_Remote_Chain_Duplicate_Transactions',
    FailureConsumerRemoteChainUnlinked = <any> 'Failure_Consumer_Remote_Chain_Unlinked',
    FailureConsumerRemoteChainDifficultiesMismatch = <any> 'Failure_Consumer_Remote_Chain_Difficulties_Mismatch',
    FailureConsumerRemoteChainScoreNotBetter = <any> 'Failure_Consumer_Remote_Chain_Score_Not_Better',
    FailureConsumerRemoteChainTooFarBehind = <any> 'Failure_Consumer_Remote_Chain_Too_Far_Behind',
    FailureConsumerRemoteChainTooFarInFuture = <any> 'Failure_Consumer_Remote_Chain_Too_Far_In_Future',
    FailureConsumerBatchSignatureNotVerifiable = <any> 'Failure_Consumer_Batch_Signature_Not_Verifiable',
    FailureExtensionPartialTransactionCachePrune = <any> 'Failure_Extension_Partial_Transaction_Cache_Prune',
    FailureExtensionPartialTransactionDependencyRemoved = <any> 'Failure_Extension_Partial_Transaction_Dependency_Removed',
    FailureExtensionReadRateLimitExceeded = <any> 'Failure_Extension_Read_Rate_Limit_Exceeded'
}
